
package de.ivu.elect.presentation.wahlvorschlag.menu;

import static java.util.Arrays.asList;

import java.util.List;

import javax.inject.Inject;

import de.ivu.elect.business.gebietsbaum.boundary.GebietSessionSelect;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.jee.presentation.redirect.Redirect;
import de.ivu.elect.presentation.View;
import de.ivu.elect.presentation.dokumente.menu.DokumentErzeugenMenuItemEntry;
import de.ivu.elect.presentation.menu.AbstractMenuItemEntry;
import de.ivu.elect.presentation.security.AbstractGebietSecurity;
import de.ivu.elect.presentation.wahlvorschlag.ListeSearchView;
import de.ivu.elect.presentation.wahlvorschlag.dokumente.WahlvorschlaegeAlsListeDokumentErzeugenView;

public class ListeWahlvorschlaegeAlsListeDokumentErzeugenMenuItemEntry extends AbstractMenuItemEntry implements DokumentErzeugenMenuItemEntry {

  private static final long serialVersionUID = 1L;

  @Inject
  private transient GebietSessionSelect gebietSessionSelect;

  @View
  @Inject
  private transient ListeSearchView listeSearchView;

  @View
  @Inject
  private transient WahlvorschlaegeAlsListeDokumentErzeugenView wahlvorschlaegeAlsListeDokumentErzeugenView;

  public ListeWahlvorschlaegeAlsListeDokumentErzeugenMenuItemEntry() {
    super();
  }

  @Override
  public boolean isRendered() {
    return hasUseCasePermission(UseCasePermission.DOKUMENT_ERZEUGEN_WAHLVORSCHLAEGE_ALS_LISTE);
  }

  @Override
  protected AbstractGebietSecurity getGebietSecurity() {
    return getEinsehenGebietSecurity();
  }

  @Override
  public boolean isDisabledInternal() {
    return !gebietSessionSelect.isSelected();
  }

  @Override
  public String getTargetViewId() {
    return null; // doAction!
  }

  @Override
  @Redirect
  public String doAction() {
    return wahlvorschlaegeAlsListeDokumentErzeugenView.initWahlvorschlaege(listeSearchView.getSearchResult());
  }

  @Override
  protected List<String> getAdditionalTopicViewIds() {
    return asList(WahlvorschlaegeAlsListeDokumentErzeugenView.VIEW_ID);
  }

  @Override
  public String getLabelKey() {
    return "liste.action.wahlvorschlaege.drucken";
  }

  @Override
  public String getIcon() {
    return getIcons().getIconPrint();
  }
}
